// R O B O P E T  ARDUINO NANO 3 RGB LED
String Version = "Ver: 1.5";
#include <Adafruit_SSD1306.h>
#include <EEPROM.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
// SSD1306 display connected to I2C (SDA = A4, SCL = A5 pins)
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

#include <FluxGarage_RoboEyes.h>
roboEyes roboEyes; // create eyes

#include <Pushbutton.h> // Pushbutton library by Pololu, can be found in the Arduino library manager

// Create buttons and define their pins

Pushbutton buttonFeed(12);   // Feed
Pushbutton buttonMedis(11);  // Medis
Pushbutton buttonSleep(10);  // Sleep
#define buttonPlay 9
Pushbutton buttonInfos(8);  // Info

#define LED_Head_R A3
#define LED_Head_G A2
#define LED_Head_B A1
#define LED2_R 7
#define LED2_G 6
#define LED2_B 5
#define LED_R 4
#define LED_G 3
#define LED_B 2
#define ResetKey A0
#define Buzzer 13


int Hungry = 0;
int Sick = 0;
int Alarm = 0;
int Mood = 100;               // Var for random events
int RanNum = 0;
int Age = 0;
int OverMed = 0;
int Minuten = 0;
int ScoreTimer = 0;
byte RIP = 0;
String Status = "";
unsigned long Timer = 0;



void setup() {
  pinMode(Buzzer, OUTPUT); 
  pinMode(buttonPlay, INPUT_PULLUP);
  pinMode(ResetKey, INPUT_PULLUP);
  pinMode(LED_Head_R, OUTPUT);
  pinMode(LED_Head_G, OUTPUT);
  pinMode(LED_Head_B, OUTPUT);
  pinMode(LED2_R, OUTPUT);
  pinMode(LED2_G, OUTPUT);
  pinMode(LED2_B, OUTPUT);
  pinMode(LED_R, OUTPUT);
  pinMode(LED_G, OUTPUT);
  pinMode(LED_B, OUTPUT);

  digitalWrite(Buzzer, HIGH); 
  delay(5);    
  digitalWrite(Buzzer, LOW);
  
  //Display starup delay
  for (int i = 0; i <= 10; i++) {
    digitalWrite(LED_Head_G, HIGH);
    delay(100);
    digitalWrite(LED_Head_G, LOW);
    delay(100);
    digitalWrite(LED2_G, HIGH);
    delay(100);
    digitalWrite(LED2_G, LOW);
    delay(100);
    digitalWrite(LED_G, HIGH);
    delay(100);
    digitalWrite(LED_G, LOW);
    delay(10);
  }

  
 
  // Initialize OLED display
  // SSD1306_SWITCHCAPVCC = generate display voltage from 3.3V internally
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3C or 0x3D
    while (true) {
      digitalWrite(LED_Head_R, HIGH);
      delay(100);
      digitalWrite(LED_Head_R, LOW);
      delay(100);

    }
  }

  // Startup robo eyes
  roboEyes.begin(SCREEN_WIDTH, SCREEN_HEIGHT, 100); // screen-width, screen-height, max framerate
  roboEyes.close(); // start with closed eyes 
  roboEyes.setPosition(DEFAULT); // eyes should be initially centered

  // Define eyes behaviour for demonstration
  roboEyes.setAutoblinker(ON, 3, 2); // Start auto blinker animation cycle -> bool active, int interval, int variation -> turn on/off, set interval between each blink in full seconds, set range for random interval variation in full seconds
  roboEyes.setIdleMode(ON, 3, 1); // Start idle animation cycle (eyes looking in random directions) -> set interval between each eye repositioning in full seconds, set range for random time interval variation in full seconds

  //display.invertDisplay(true); // show inverted display colors (black eyes on bright background)
  roboEyes.setCuriosity(ON);
  Timer = (millis()/1000);
  display.setTextColor(WHITE);
  display.clearDisplay(); 
  //display.setRotation(2);   // ROTATE SCREEN iif text is upside down
  display.setTextSize(2);
  display.clearDisplay(); 
  display.setCursor(0,0);
  display.println(F("ROBO PET"));
  display.println(Version);
  display.println(F("Smf 2025"));
  display.setTextSize(1);
  display.println(F(""));
  display.print(F("smurfys.ch"));
  display.display();
  delay(5000);

  //NEWSTART();  RESETING THE EEPROM TO ZERO
  Check_Akku_Restart();
  Scoring();
  ScoreTimer = 15;
 
} // end of setup

//*******       MAIN LOOP START       *******
void loop() {
  roboEyes.update();  // Updates eye drawings
  readButtons();
  if (ScoreTimer == 20){
    RandomEvent();
    Scoring();
    ScoreTimer = 0;
  }
  
  if((millis()/1000) > Timer + 59){
    Timer = (millis()/1000); 
    Minuten += 1;
    ScoreTimer += 1;
    if(Minuten > 1439){
      Minuten = 0;
      One_Day_Done();
    }
  }
} // end of main loop
//*******       MAIN LOOP END        *******


//*******       LEVEL I PROCEDURES        *******

void Check_Akku_Restart(){
  display.setTextColor(WHITE);
  display.clearDisplay(); 
  display.setTextSize(1);
  display.setCursor(0,20);
  Age = (EEPROM.read(10) << 8) + EEPROM.read(11);
  delay(100);
  if (Age < 1){
    Age = 0;
  }
  RIP = (EEPROM.read(25));
  delay(100);
  if (RIP > 0){
    GAME_OVER();
  }
  Alarm = (EEPROM.read(15));
  delay(100);
  Sick = (EEPROM.read(20));
  delay(100);
  OverMed = (EEPROM.read(30));
  delay(100);
  if(Age == 0){
    display.clearDisplay(); 
    display.setCursor(0,0);
    display.println(F("FIRST START"));
    display.println(F(""));
    display.println(F("BOOTING NOW"));
    display.display();
    delay(2000);
    NEWSTART();
  }
  if(Age !=0){
    Hungry = Hungry + 20;
    Sick = Sick + 5;
    display.clearDisplay(); 
    display.setCursor(0,0);
    display.println(F("RESTART"));
    display.print(F("Age    :"));
    display.println(Age);
    display.print(F("Hunger :"));
    display.println(Hungry);
    display.print(F("Sick   :"));
    display.println(Sick);
    display.print(F("Alarm  :"));
    display.println(Alarm);
    display.print(F("OverMed:"));
    display.println(OverMed);
    display.display();
    delay(10000);
  }
}



void readButtons(){
   if (buttonInfos.getSingleDebouncedPress()){
    Beep();
    Status = "INFOS";
    Infos();
   }

   if (buttonFeed.getSingleDebouncedPress()){
    Beep();
    if(Hungry < 50 && Sick < 20){
      roboEyes.setHFlicker(OFF);
      roboEyes.setMood(DEFAULT);
      NoLed();
      roboEyes.update();
    }
    Status = "FOOD";
    Hungry = Hungry - 5;
    display.setTextSize(2);
    display.clearDisplay(); 
    display.setCursor(0,0);
    display.println(F("EATING"));
    display.setCursor(0,20);
    display.println(F("gobble..."));
    display.print(Hungry);
    display.println(F(" %"));
    display.display();
    delay(1000);
    if (Mood < 90 ){
      Mood = Mood + 1;
    }
    if (Hungry < -2){
      BeepWarn();
      Mood = Mood - 5;
      display.clearDisplay(); 
      display.setTextSize(2);
      display.clearDisplay(); 
      display.setCursor(0,0);
      display.println(F("FULL NOW"));
      display.println(F("don't feed"));
      display.println(F("me more"));
      display.display();
      delay(2000);
    }
    if (Hungry < -15){
      BeepWarn();
      Mood = Mood - 5;
      Sick = Sick + 2;
      Hungry = -15;
    }
   }
  
  if (buttonSleep.getSingleDebouncedPress()){
    Beep();
    Status = "SCHLAFE";
    digitalWrite(LED_Head_B, HIGH);
    Hungry = Hungry + 2;
    Mood = Mood + 5;
    Sick = Sick - 1;
    if (Sick < 0){
      Sick = Sick + 1;
    }
    for (int i = 0; i <= 4200; i++) {
      display.clearDisplay(); 
      roboEyes.close();
      roboEyes.update();
      delay(3000);
      display.clearDisplay(); 
      display.setCursor(0,0);
      display.println(F("SLEEPING"));
      display.setCursor(0,22);
      display.print(300 - (i/12));
      display.println(F(" MIN."));
      display.println(i);
      display.display();
      delay(2000);
      if(digitalRead(10) == 0){
        Beep();
        NoLed();
        display.clearDisplay(); 
        display.setCursor(0,20);
        display.println(F("WAKING UP"));
        display.print(F("takes a while"));
        display.display();
        i = 4199;
        delay(1000);
      }
    }
    NoLed();
   }

  if (buttonMedis.getSingleDebouncedPress()){
    Status = "MEDIS";
    Beep();
    Sick = Sick - 5;
    if (Sick < 1){
      BeepWarn();
      Mood = Mood - 10;
      display.setTextSize(2);
      display.clearDisplay(); 
      display.setCursor(0,0);
      display.println(F("WARNING!"));
      display.println(F("TOO MUCH"));
      display.println(F("MEDICATION"));
      display.display();
      delay(3000);
    }
    if(Sick < -10){
      BeepWarn();
      Mood = Mood - 10;
      OverMed = OverMed + 2;
      Sick = -10;
    }
    display.setTextSize(2);
    display.clearDisplay(); 
    display.setCursor(0,0);
    display.println(F("MEDICATION"));
    display.setTextSize(1);
    display.setCursor(0,25);
    display.print(F("yuck!...."));
    display.println(F(" grumble"));
    display.println(" ");
    display.setTextSize(2);
    display.print(F("Sick"));
    display.print(Sick);
    display.println(F("%"));
    display.display();
    delay(3000);
   }
  
  if (digitalRead(buttonPlay) == 0){
    Status = "PLAY";
    Beep();
    NoLed();
    digitalWrite(LED_Head_B, HIGH);
    digitalWrite(LED_Head_G, HIGH);
    roboEyes.setCyclops(ON);
    Mood = Mood + 5;
    int i = 0;
    int x = 0;
    display.setTextSize(1);
    while (digitalRead(buttonPlay) == 0){
      i = i + 1;
      if (i > 20000){
        delay(1000);
        roboEyes.anim_confused();
        roboEyes.update();
        display.setCursor(0,3);
        display.println(Mood);
        display.println(OverMed);
        display.display();
        Mood = Mood + 1;
        x = x + 1;
        if (x == 25 and OverMed > 1){
          OverMed = OverMed - 1;
          x = 0;
          }
        if (Mood > 150){
          Mood = 150;
        }
        i = 0;
      }
    }
  }
  roboEyes.setCyclops(OFF); 
}



void RandomEvent(){
  if(Mood < 0){
    Mood = 0;
  }
  RanNum = random(Mood + 50);
  if(RanNum == 5) {
    Hungry = Hungry + 2;
  }
  if(RanNum == 10) {
    Hungry = Hungry + 3;
  }
  if(RanNum == 15) {
    Hungry = Hungry + 5;
  }
  if(RanNum == 20) {
    Mood = Mood - 1;
  }
  if(RanNum == 25) {
    Mood = Mood - 5;
  }
  if(RanNum == 30)  {
    Mood = Mood - 15;
  }
  if(RanNum == 35) {
    Sick = Sick + 3;
  }
  if(RanNum == 40) {
    Sick = Sick + 5;
  }
  if(RanNum == 70) {
    Sick = Sick + 10;
  }
  if(OverMed > 90){
    Alarm = Alarm + 2;
  }
  RanNum = random(105 - OverMed);
  if (RanNum == 3 && OverMed > 10){
    Sick = Sick + 10;
    Mood = Mood - 10;
  }
}



void Scoring(){
  Hungry = Hungry + 1;
  roboEyes.update();  // Updates eye drawings

  if(Hungry > 99){
    Hungry = 100;
    Sick = Sick + 1;
  }
  if(Sick > 99){
    Sick = 100;
    Alarm = Alarm + 1;
  }

  if(Hungry < 50 && Sick < 20){
    Alarm = 0;
    roboEyes.setHFlicker(OFF);
    roboEyes.setMood(DEFAULT);
    NoLed();
  }

  if(Hungry > 50){
    NoLed();
    digitalWrite(LED_Head_G, HIGH);
    roboEyes.setHFlicker(OFF);
    roboEyes.setMood(DEFAULT);
  }

  if(Hungry > 70){
    NoLed();
    digitalWrite(LED_Head_B, HIGH);
    roboEyes.setHFlicker(OFF);
    roboEyes.setMood(TIRED);
    Sick = Sick + 1;
    digitalWrite(LED_Head_G, HIGH);
  }

  if(Hungry > 95){
    NoLed();
    digitalWrite(LED_Head_B, HIGH);
    digitalWrite(LED2_B, HIGH);
    digitalWrite(LED_B, HIGH);
    roboEyes.setHFlicker(OFF);
    roboEyes.setMood(ANGRY);
    Sick = Sick + 1;
  }

  if(Sick > 30){
    NoLed();
    digitalWrite(LED_Head_R, HIGH);
    digitalWrite(LED2_G, HIGH);
    roboEyes.setHFlicker(OFF);
    roboEyes.setMood(TIRED);
  }

  if(Sick > 50){
    NoLed();
    digitalWrite(LED_Head_R, HIGH);
    digitalWrite(LED2_G, HIGH);
    digitalWrite(LED_B, HIGH);
    roboEyes.setMood(ANGRY);
  }

  if(Sick > 80){
    NoLed();
    digitalWrite(LED_Head_R, HIGH);
    digitalWrite(LED2_B, HIGH);
    digitalWrite(LED_B, HIGH);
    roboEyes.setMood(HAPPY);
    roboEyes.setHFlicker(ON); 
    Alarm = Alarm + 1;
  }

  if(Alarm > 0){
    NoLed();
    digitalWrite(LED_Head_R, HIGH);
    digitalWrite(LED2_R, HIGH);
    roboEyes.setMood(HAPPY);
    roboEyes.setHFlicker(ON); 
  }

  if(Alarm > 30){
    NoLed();
    digitalWrite(LED_Head_R, HIGH);
    digitalWrite(LED2_R, HIGH);
    digitalWrite(LED_G, HIGH);
    roboEyes.setMood(HAPPY);
    roboEyes.setHFlicker(ON); 
    roboEyes.anim_laugh();
    Alarm = Alarm + 1;
  }

  if(Alarm > 60){
    NoLed();
    digitalWrite(LED_Head_R, HIGH);
    digitalWrite(LED2_R, HIGH);
    digitalWrite(LED_B, HIGH);
    roboEyes.setMood(HAPPY);
    roboEyes.setHFlicker(ON); 
    roboEyes.anim_laugh();
    roboEyes.anim_confused();
    Alarm = Alarm + 1;
  }

  if(Alarm > 85){
    NoLed();
    digitalWrite(LED_Head_R, HIGH);
    digitalWrite(LED2_R, HIGH);
    digitalWrite(LED_R, HIGH);
    roboEyes.setMood(HAPPY);
    roboEyes.setHFlicker(ON); 
    roboEyes.anim_laugh();
    delay(100);
    roboEyes.anim_confused();
    Alarm = Alarm + 1;
  }

  if (Alarm > 99){
    RIP = 100;
    One_Day_Done();
    GAME_OVER();
  }
  roboEyes.update();
}



//*******       LEVEL II PROCEDURES        *******

void One_Day_Done(){
  Age = Age + 1;
  if (Age < 0){
    Age = 0;
  }
  EEPROM.write(10, Age >> 8);
  delay(50);
  EEPROM.write(11, Age & 0xFF);
  delay(50);
  EEPROM.write(15, Alarm);
  delay(50);
  EEPROM.write(20, Sick);
  delay(50);
  EEPROM.write(25, RIP);
  delay(50);
  EEPROM.write(30, OverMed);
  delay(50);
}

void Infos(){
  display.clearDisplay(); 
  display.setTextSize(1);
  display.setCursor(0,0);
  display.println(Version);
  display.print(F("AGE          "));
  display.print(Age);
  display.println(F(" days"));
  display.print(F("Hunger       "));
  display.print(Hungry);
  display.println(F(" %"));
  display.print(F("Sick         "));
  display.print(Sick);
  display.println(F(" %"));
  display.print(F("Fitness      "));
  int Fns = Mood;
  if (Fns > 100){
    Fns = 100;
  }
  display.print(Fns);
  display.println(F(" %"));
  display.print(F("Immunsystem  "));
  display.print(100 - OverMed);
  display.println(F(" %"));
  display.print(F("Day hours left "));
  display.print((1440 - Minuten) / 60);
  display.display();
  delay(10000); 
}



void NoLed(){
  digitalWrite(LED_Head_R, LOW);
  digitalWrite(LED_Head_G, LOW);
  digitalWrite(LED_Head_B, LOW);
  digitalWrite(LED2_R, LOW);
  digitalWrite(LED2_G, LOW);
  digitalWrite(LED2_B, LOW);
  digitalWrite(LED_R, LOW);
  digitalWrite(LED_G, LOW);
  digitalWrite(LED_B, LOW);
}



void GAME_OVER(){
  NoLed();
  digitalWrite(LED_Head_R, HIGH);
  roboEyes.setCuriosity(OFF);
  roboEyes.setHFlicker(OFF);
  EEPROM.write(15, 10);
  while (digitalRead(ResetKey) == 1){
    roboEyes.close();
    roboEyes.update();
    display.setCursor(0,0);
    display.setTextSize(2);
    display.println(F("Game Over!"));
    display.setTextSize(1);
    display.setCursor(0,35);
    display.print(F("Days "));
    display.println(Age);
    display.print(F("ENTER RESET KEY"));
    display.display();
     digitalWrite(LED_Head_R, HIGH);
    delay(500);
     digitalWrite(LED_Head_R, LOW);
    delay(500);
  }
  display.clearDisplay(); 
  display.setCursor(0,0);
  display.print(F("Days "));
  display.println(Age);
  display.println(F(""));
  display.print(F("WAIT"));
  display.display();
  delay(10000);
  NEWSTART();
  display.clearDisplay(); 
  display.setCursor(0,0);
  display.print(F("REPLUG NOW"));
  display.display();
  delay(1000000);
}


void NEWSTART(){
  digitalWrite(LED_Head_B, HIGH);
  Age = 0;
  EEPROM.write(10, Age >> 8);    //AGE FIRST 2 DIGIT
  delay(50);
  EEPROM.write(11, Age & 0xFF);  //AGE SECOND 2 DIGIT
  delay(50);
  EEPROM.write(15, 0);   //Alarm
  delay(50);
  EEPROM.write(20, 0);   //Sick
  delay(50);
  EEPROM.write(25, 0);   //RIP   
  delay(50);
  EEPROM.write(30, 0);   //OverMed
  delay(200);
  NoLed();
}

void Beep(){
  digitalWrite(LED_Head_G, HIGH);
  digitalWrite(Buzzer, HIGH); 
  delay(5);    
  digitalWrite(Buzzer, LOW);
  digitalWrite(LED_Head_G, LOW);
}


void BeepWarn(){
  digitalWrite(LED_Head_R, HIGH);
  digitalWrite(Buzzer, HIGH); 
  delay(50);    
  digitalWrite(Buzzer, LOW);
  digitalWrite(LED_Head_R, LOW);
}


 